///////////////////////////////////////////////////////////////////////////
// Filename : SMC.h
// Project  : Ans_MP3_Player/MP3_Decoder
// Author   : GoodKook / goodkook@nms.anslab.co.kr
// Company  : AnsLab Co. / http://www.anslab.co.kr
// Revision :
// Comment  :
//
//

#ifndef SMC_INC
#define SMC_INC

#ifndef SOFT
    extern "C" {
        #include "ilibdd.h"
        #include "iflib_i2s_IMV2_dd.h"
        #include "iflib_i2s_OMV2_dd.h"
    }
#endif

#include "systemc.h"

enum S_SMC_Type {
    S_SMC_WAIT,
    S_SMC_REQ,
    S_SMC_ACK
};

SC_MODULE(smc)
{
    sc_in_clk           clk;                // Clock
    sc_in<sc_bit>       rst;                // Reset
    sc_out<sc_bit>      eof;                // End-of-File: Input stream

    sc_out<sc_bit>      mp3_ack;
    sc_in<sc_bit>       mp3_req;
    sc_out<sc_bv<8> >   mp3_data;

    sc_out<int>         mp3_count;

    // Process ///////////////////////////////////////////////////////////
    void proc_smc();

    // Signals ///////////////////////////////////////////////////////////
    sc_signal<S_SMC_Type>   SMC_State;

    char    filename[64];
    FILE    *mp3_fp;
    int     count;

    // Public helpers
    void Open( const char *filename ){
        mp3_fp = fopen(filename, "r+b");
        if( mp3_fp == NULL ) {
            fprintf(stderr, "MP3 File \"%s\" not found!", filename);
            exit(-1);
            }

        // PCM Data output filename ///////////////////////
        strcpy(u_mp3_decoder.pcm_filename, filename);
        }

    // Constructor ///////////////////////////////////////////////////////////
    SC_CTOR(smc) {
        SC_METHOD(proc_smc);
        sensitive << clk << rst;
    }
};

#endif
