/* ID number */
#define I2SI_ID         0
#define I2SO_ID         1
#define I2C_ID          2

#if 0

/* INPUT pin assign */
#define PSG_POR_        0x804   /* 5: */
#define PSG_TE          0x800   /* 6: */
#define PSG_WSEN        0x808   /* 11: */
#define PSG_PCS_        0x80C   /* 36: */
#define PSG_PR          0x810   /* 37: */
#define PSG_VSENS       0x814   /* 38: */
#define PSG_DCEN        0x818   /* 44: */

/* OUTPUT pin assign */
#define PSG_WRDY        0xA00   /* 10: */
#define PSG_PUP         0xA04   /* 12: */
#define PSG_PI19        0xA08   /* 35: (INOUT) */
#define PSG_DCSO        0xA0C   /* 39: */
#define PSG_PTW_        0xA10   /* 41: */
#define PSG_PTR_        0xA14   /* 42: */
#define PSG_EOD_        0xA18   /* 43: */

/* INOUT pin assign */
#define PSG_P0          0xC00   /* 14: (IN) OUT */
#define PSG_PI1         0xC04   /* 15: (IN) OUT */
#define PSG_PI2         0xC08   /* 16: (IN) OUT */
#define PSG_PI3         0xC0C   /* 17: (IN) OUT */
#define PSG_PI4         0xC10   /* 18: (IN) OUT */
#define PSG_PI8         0xC14   /* 24: (IN) OUT */
#define PSG_PI12        0xC18   /* 28: */
#define PSG_PI13        0xC1C   /* 29: */
#define PSG_PI14        0xC20   /* 30: */
#define PSG_PI15        0xC24   /* 31: */
#define PSG_PI16        0xC28   /* 32: */
#define PSG_PI17        0xC2C   /* 33: */
#define PSG_PI18        0xC30   /* 34: */

/* SUPPLY assign */
#define PSG_VSS         0xD80   /* 1: */
#define PSG_VDD         0xD84   /* 2: */
#define PSG_AVSS        0xD88   /* 7: */
#define PSG_AVDD        0xD8C   /* 9: */
#define PSG_XVSS        0xD90   /* 22: */
#define PSG_XVDD        0xD94   /* 23: */
#define PSG_DCSG        0xD98   /* 40: */

#endif

#define PSG_TE          (0x800 | (0 << 2 ))
#define PSG_POR_            (0x800 | (1 << 2 ))
#define PSG_VDD             (0x800 | (4 << 2 ))
#define PSG_VSS             (0x800 | (5 << 2 ))
#define PSG_DCEN            (0x800 | (6 << 2 ))
#define PSG_EOD_            (0x800 | (7 << 2 ))
#define PSG_PTR_            (0x800 | (8 << 2 ))
#define PSG_RTW_            (0x800 | (9 << 2 ))
#define PSG_DCSG            (0x800 | (10    << 2 ))
#define PSG_DCSO            (0x800 | (11    << 2 ))
#define PSG_VSENS           (0x800 | (12    << 2 ))
#define PSG_PR              (0x800 | (13    << 2 ))
#define PSG_PCS_            (0x800 | (14    << 2 ))
#define PSG_PI19            (0x800 | (15    << 2 ))
#define PSG_PI18            (0x800 | (16    << 2 ))
#define PSG_PI17            (0x800 | (17    << 2 ))
#define PSG_PI16            (0x800 | (18    << 2 ))
#define PSG_PI15            (0x800 | (19    << 2 ))
#define PSG_PI14            (0x800 | (20    << 2 ))
#define PSG_PI13            (0x800 | (21    << 2 ))
#define PSG_PI12            (0x800 | (22    << 2 ))
#define PSG_PI8             (0x800 | (26    << 2 ))
#define PSG_XVDD            (0x800 | (27    << 2 ))
#define PSG_XVSS            (0x800 | (28    << 2 ))
#define PSG_PI4             (0x800 | (32    << 2 ))
#define PSG_PI3             (0x800 | (33    << 2 ))
#define PSG_PI2             (0x800 | (34    << 2 ))
#define PSG_PI1             (0x800 | (35    << 2 ))
#define PSG_PI0             (0x800 | (36    << 2 ))
#define PSG_PUP             (0x800 | (38    << 2 ))
#define PSG_WSEN            (0x800 | (39    << 2 ))
#define PSG_WRDY            (0x800 | (40    << 2 ))
#define PSG_AVDD            (0x800 | (41    << 2 ))
#define PSG_AVSS            (0x800 | (43    << 2 ))


/* Alias */
#define PSG_DEMAND      PSG_PI19
#define PSG_I2C_READY       PSG_I2C_WSTAT
#define PSG_I2C_VALID       PSG_I2C_RSTAT
#define PSG_IIC         PSG_I2C
#define PSG_IIC_READY       PSG_I2C_WSTAT
#define PSG_IIC_VALID       PSG_I2C_RSTAT
#define PSG_SID_VALID       PSG_SID_RSTAT
#define PSG_SOD_READY       PSG_SOD_WSTAT

