///////////////////////////////////////////////////////////////////////////
// Filename : sc_III_Stereo.h
// Project  : MP3 Decoder
// Author   : GoodKook / goodkook@nms.anslab.co.kr
// Company  : AnsLab Co. / http://www.anslab.co.kr
// Revision :
// Comment  :
//
//
#ifndef III_STEREO_INC
#define III_STEREO_INC

#include "systemc.h"

enum tStereo_State {
    S_STEREO_WAIT,
    S_STEREO_DECODE,
    S_STEREO_DOWNLOAD,
    S_STEREO_BUSY };

SC_MODULE(iii_stereo)
{
    sc_in_clk           clk;    // Clock
    sc_in<sc_bit>       rst;    // Reset

    sc_in<sc_bit>       start;  // Stereo Start
    sc_out<sc_bit>      ready;  // Stereo Ready

    sc_in<sc_bit>       stereo;
    sc_in<sc_bv<2> >    mode;
    sc_in<sc_bv<2> >    mode_ext;
    sc_in<sc_bv<9> >    scalefac_compress;
    sc_in<sc_bv<2> >    sampling_freq;
    sc_in<sc_bit>       version;
    sc_in<sc_bv<2> >    block_type;
    sc_in<sc_bit>       window_switching_flag;
    sc_in<sc_bit>       mixed_block_flag;

    // Process ///////////////////////////////////////////////////////////
    void proc_stereo();

    // FSM ///////////////////////////////////////////////////////////////
    sc_signal<tStereo_State>    Stereo_State;   // FSM State Variable

    // Prototypes ////////////////////////////////////////////////////////
    void III_stereo(
        int     stereo,
        int     mode,
        int     mode_ext,
        int     scalefac_compress,
        int     sampling_freq,
        int     version,
        int     window_switching_flag,
        int     block_type,
        int     mixed_block_flag );

    void III_i_stereo_k_values(
        int is_pos,
        double io,
        int i,
        double k[2][576] );

    // Constructor ///////////////////////////////////////////////////////////
    SC_CTOR(iii_stereo)
    {
        SC_METHOD(proc_stereo);
        sensitive << clk << rst;
    }
};

#endif
