///////////////////////////////////////////////////////////////////////////
// Filename : sc_III_Decoder_Mem.cpp
// Project  : Ans_MP3_Player/MP3_Decoder
// Author   : GoodKook / goodkook@nms.anslab.co.kr
// Company  : AnsLab Co. / http://www.anslab.co.kr
// Revision : 5-4-01: Modified for interface to untimed SystemC testbench
//                    - John Stickley, Ikos Systems, Inc. (johns@ikos.com)
// Comment  :
//

#include "sc_III_Decoder_Mem.h"

decoder_mem *GlobalDecoderMem;

// Initialize Frame Buffer /////////////////////////////////////////////////////
void decoder_mem::proc_mem_init()
{
    int ch, sb, ss, cb, win;

    if (rst.read()==(sc_bit)'0')    // Async. Reset
    {
        m_init_done = (sc_bit)'0';
        Mem_Init_State = S_MEM_INIT_WAIT;
    }
    else if (clk.event() && clk.read()==(sc_bit)'1')    // Clocking Rising-Edge
    {
        switch(Mem_Init_State.read())
        {
            case S_MEM_INIT_WAIT:
                if (mem_init.read()==(sc_bit)'1')
                {
                    m_init_done = (sc_bit)'0';
                    Mem_Init_State = S_MEM_INIT_BUSY;
                }
                break;

            case S_MEM_INIT_BUSY:
                // Initialize Decoder Memory
                for (ch=0; ch<2; ch++)
                {
                    for (cb=0; cb<23; cb++)
                        scalefac[ch].l[cb] = 0;
                    for (cb=0; cb<13; cb++)
                        for (win=0; win<3; win++)
                            scalefac[ch].s[win][cb] = 0;

                    for (sb=0; sb < SBLIMIT; sb++)
                        for (ss=0; ss < SSLIMIT; ss++)
                        {
                            ram[ch][sb][ss] = 0.0;
                            prevblck[ch][sb][ss] = 0.0;
                        }
                }

                for (ss=0; ss < SSLIMIT*2; ss++)
                    rawout[ss] = 0.0;

                m_init_done = (sc_bit)'1';
                Mem_Init_State = S_MEM_INIT_DONE;
                break;

            case S_MEM_INIT_DONE:
                if (mem_init.read()==(sc_bit)'0')
                {
                    m_init_done = (sc_bit)'0';
                    Mem_Init_State = S_MEM_INIT_WAIT;
                }
                break;
        }
    }
}
