#include <stdio.h>

unsigned long updateCrc( int ch, unsigned long CRC );
unsigned long genFileCrc( char *filename, unsigned long CRC );

main( argc, argv )
    int argc;
    char *argv[];
{   int usage = 0, i;

    if( argc < 2 )
        usage = 1;

    else if( argc == 2 && !strcmp( argv[1], "-" ) )
        printf( "%8lx\n", genFileCrc( "", 0xFFFFFFFFL ) );

    else if( !strcmp( argv[1], "-each" ) ){
        if( argc > 2 )
            for( i=2; i<argc; i++ )
                printf( "%s: %8lx\n", argv[i], genFileCrc( argv[i], 0xFFFFFFFFL ) );
        else
            usage = 1;
        }
    else{
        unsigned long CRC = 0xFFFFFFFFL;

        for( i=1; i<argc; i++ )
            CRC = genFileCrc( argv[i], CRC );
        printf( "%8lx\n", CRC );
        }

    if( usage ){
        printf( "usage: 'sign -'                CRC from stdin\n" );
        printf( "       'sign [-each] <file(s)> CRC from file(s)\n" );
        printf( "\nNote:\n" );
        printf( "        If '-each' is specified, individual CRC's are generated for\n" );
        printf( "    each file, o/w a composite CRC is generated for all files.\n\n" );
        }
    exit( usage );
    }
